var attrs_str = 'St,Le,Wi,Dx,To,Ch,Ap,Ma,Pe'
, presets = 
  { 'plain':   { Le:12, Ma:12, Ch:12, Wi:12, Dx:12, Pe:12, To:12, St:12, Ap:12, title:'reset'}
  , 'caster':  { Le:20, Ma:30, Ch:25, Wi:25, Dx:10, Pe: 8, To: 9, St: 7, Ap: 6, title:'magic users'}
  , 'fighter': { St:30, To:30, Dx:20, Pe:10, Le:10, Ch: 6, Wi: 6, Ap: 6, Ma: 6, title:'plain warriors'}
  , 'avail':   { Le:30, Ma:30, Ch:20, Wi:15, Dx:15, Pe:15, To:10, St:10, Ap: 6, title:'based somewhat upon "trainability", availability and overal "value" (for casters)'}
  }    
, attrs_nodes = {} // Le: [tt nodes], Ma:[tt nodes] ... , filled after load
, statistics = {}  // Le: {'+':nr, '++':nr, '-': nr, '--': nr}, Ma: ... , , filled after load
, ths  // questions are in THs, nodelist filled after load
, load_preset = function ( preset ) // presets are binded directly, see above
  { attrs_str.replace // who wants foreach :]
    ( /[^,]{2}/g
    , function(m) { pref_change( m , preset[m] ) }
    )
  }
, pref_change = function ( attr_str , size )
  { var el , i = -1
  ; while ( el = attrs_nodes[attr_str][++i] )
      el.style.fontSize = size + 'pt'
      // doing it this (dumb) way because manipulating stylesheet in IE is PITA
      // or, more exactly, reaises unhadleable exception :|
      // it's slower and more demanding than easy style.innerHTML manipulation
      // but is is still quite bearable, even on weak machines.
  }
, filter = function( txt )
  { var th , i = -1
  ; while( th = ths[++i] )
    { th.parentNode.parentNode      // tbody > tr > th
      .style.display 
      = th.innerHTML.toLowerCase()  
        .indexOf( txt.toLowerCase() ) 
        == -1                    
        ? 'none'                  
        : 'table-row-group'       
    }
  }
; onload = function()
  { ths = document.getElementsByTagName('th')
  // make "load presets" buttons
  ; for ( var preset_name in presets )
    { var b = document.createElement('button')
    ; b.innerHTML = preset_name
    ; b.title = presets[preset_name].title
    ; b.onclick = 
      ( function( preset_obj )
        { return function()
          { load_preset( preset_obj )
          }
        }
      )( presets[preset_name] )
    ; document.getElementById('presets').appendChild( b )
    }
  // make "adjust" buttons
  ; document.getElementById('adjusts').innerHTML =
    attrs_str.replace
    ( /[^,]{2}/g
    , function(m)
      { attrs_nodes[m] = []
      ; statistics[m] = { '+':0, '++':0, '-':0, '--':0 }
      ; return '<tt class="'+m+'" style="font-size:12pt">'
        + '<button onclick="pref_change(\''+m+'\', parseInt(this.parentNode.style.fontSize)+1)">+<\/button>'
        + m 
        + '<button onclick="pref_change(\''+m+'\', parseInt(this.parentNode.style.fontSize)-1)">-<\/button>'
        + '<\/tt>'
      }
    )
  ; var tts = document.getElementsByTagName('tt')
     ,  rx = /[^-+]*/g
     ,  tt , i = -1
  ; while ( tt = tts[++i] )
    { attrs_nodes[ tt.className ].push( tt )
//     ; tt.parentNode.tagName == 'TD' && statistics[ tt.className ][ tt.innerHTML.replace(rx,'') ]++
    }
//   // just to check statistics ... now it is in q.html directly ...
//   ; var buff = [' ']
//   ; for( var s in statistics )
//     { var ss = statistics[s]
//     ; buff.push
//       ( s
//       , '+' , ss['+'] , '+' , 2*ss['++']
//       , '-' , ss['-'] , '-' , 2*ss['--']
//       , '='
//       , ss['+'] + 2*ss['++'] - ss['-'] - 2*ss['--']
//       , '\n'
//       )
//     }
//   ; document.getElementById('ssss').innerHTML = buff.join(' ')
  }
; onfocus = function() // in FF even selects its content :]
  { document.getElementsByTagName('input')[0].focus()
  }
